#ifndef   _MAC_H_
#define 	_MAC_H_

#include "config.h"

#define MAX_DATA_LENGTH 5 //maximum data length in bytes in a packet  

unsigned char DEVICE_ID;
unsigned char DEST_ID;
extern unsigned char PickDest;

#define wait_CTS 300
#define wait_DATA 200
#define wait_ACK 300
#define wait_RTT 500


//#define RTT 65 //assume distatnce is 50 meters and speed is 1500m/s


//int DATASIZE;  //actual data size to be sent (in bytes)

//int PACKET_NUMBER; //number of the packet to send the data buffer



unsigned char DATA_LENGTH = 1;

unsigned char n_RXpacket=0;//record the number of packets received 

unsigned char n_TXpacket=0;//record the number of packets sent

unsigned char TXACK=0; //record the number of ACK sent

unsigned char RXACK=0; //record the number of ACK received

unsigned char TXRTS=0;
unsigned char TXCTS=0;
unsigned char RXRTS=0;
unsigned char RXCTS=0;

unsigned int TX_data=0; //data to be sent

//unsigned char SourceID=0;


#define MAX_RETRY	10 //max retry number

enum{ID_ACK=0x80, ID_DATA=0x90, ID_RTS=0xA0,ID_CTS=0xB0} ID_TYPE;
enum {STATUS_WAIT_ACK, STATUS_WAIT_CTS,STATUS_IDEL}STATUS_TYPE;

unsigned char Status=STATUS_IDEL;

typedef struct {
	unsigned char ID; //0-ACK;1-DATA; 2-RTS; 3-CTS;
	unsigned char Dest;
	unsigned char Source;
	unsigned char Length;
	unsigned char Data[MAX_DATA_LENGTH];
	int CRC;
	} PACKET;

PACKET RTS,CTS;

PACKET P_ACK;

PACKET P_DATA;

//unsigned char DataArray[100];

void SendACK( unsigned char TO);

void SendRTS(unsigned char TO);

void SendCTS(void);

void Delay(unsigned int timeLength);

void PacketCompose(PACKET p);

PACKET Decompose(void);

void SendPacket(PACKET p);

PACKET RecPacket(short *wait, char symbols);

void SendData( unsigned char TO, unsigned char *buf);

void SaveData(PACKET p);

void MACA(void);
void Aloha(void);


#endif

