#include "config.h"

short Receiver_Coefficients[Coef_Zones * 4];

short magnitude = 0;

void AddSample(unsigned char rawchannel[(packet_size * 8) / num_channels][num_channels], unsigned char sample);
unsigned char test_Packet(unsigned char tst_packet[packet_size]);
unsigned char GenPacket(unsigned char rawchannel[(packet_size * 8) / num_channels][num_channels], unsigned char tst_packet[packet_size]);
void Recovery(unsigned char repair, unsigned char tst_packet[packet_size]);

void Fetch_RxConfiguration(void)
{
	short i;
	unsigned short n;
	for(i = 0; i < Coef_Zones * 4; i++) {
		n = EEPROM_read((i<<1)+31);
		n |= ((unsigned short)(EEPROM_read((i<<1)+31+1)) << 8);
		Receiver_Coefficients[i] = (short)n;
	}
}

short Goertzel(short coef)
{
	long Q0, Q1, Q2, n;
	long result;
	Q0 = Q1 = Q2 = 0;
	ADC_clr;
	for(n = 50; n; n--) {
		while(!ADC_tst);
		ADC_clr;
		//PORTD |= 0x8;
		Q0 = (signed long) (((Q1*coef) >> 8) - Q2 + ADC - 512);
		Q2 = Q1;
		Q1 = Q0;
		//PORTD &= ~0x8;
	}
	Q1 = Q1 >> 8;
	Q2 = Q2 >> 8;
	result = Q1 * Q1 + Q2 * Q2 - ((Q1 * Q2 * coef) >> 8);
	return result;
}
/*
short GoertzelRun(void)
{
	char txt[30];
	short n;
	short Q0a, Q1a, Q2a;
	short Q0b, Q1b, Q2b;
	short Q0c, Q1c, Q2c;
	short Q0d, Q1d, Q2d;
	short result = 0;
	short tst, min;
	char win = 7;
	Q0a = Q1a = Q2a = 0;
	Q0b = Q1b = Q2b = 0;
	Q0c = Q1c = Q2c = 0;
	Q0d = Q1d = Q2d = 0;
	ADC_clr;
	for(n = 50; n && (!(result & 0x4000)); n--) {
		PORTC &= ~0x20;
		while(!ADC_tst);
		ADC_clr;
		PORTC |= 0x20;
		min = ADC - 512;
		Q0a = ((signed short)(((signed long)Q1a*Receiver_Coefficients[0]) >> 8) - Q2a + min);
		Q2a = Q1a;
		Q1a = Q0a;
		if(Q0a < 0) tst = -Q0a;
		else tst = Q0a;
		if(result < tst) { result = tst; win = 0; }
		
		Q0b = ((signed short)(((signed long)Q1b*Receiver_Coefficients[1]) >> 8) - Q2b + min);
		Q2b = Q1b;
		Q1b = Q0b;
		if(Q0b < 0) tst = -Q0b;
		else tst = Q0b;
		if(result < tst) { result = tst; win = 1; }
		
		Q0c = ((signed short)(((signed long)Q1c*Receiver_Coefficients[2]) >> 8) - Q2c + min);
		Q2c = Q1c;
		Q1c = Q0c;
		if(Q0c < 0) tst = -Q0c;
		else tst = Q0c;
		if(result < tst) { result = tst; win = 2; }
		
		Q0d = ((signed short)(((signed long)Q1d*Receiver_Coefficients[3]) >> 8) - Q2d + min);
		Q2d = Q1d;
		Q1d = Q0d;
		if(Q0d < 0) tst = -Q0d;
		else tst = Q0d;
		if(result < tst) { result = tst; win = 3; }
	}
	magnitude = result;
	//if(result[min] <= 6) return 0;
	return win;
}
*/


void coef_Scan(void)
{
	char txt[20];
	short result, max, min;
	short coef, cmin, ctst1, ctst2, i;
	char freq;
	PRR &= ~0x01;	// enable ADC
	// Start ADC free-running
	ADMUX = 0x40 + 2;	// Vcc, ADC2
	ADC_clr;
	set_alpha("RX COEF");
	en_keys;
	//set_number(1);
	while((!B2) && (!B3)) GLED_Display();
	for(freq = 4; freq < Coef_Zones * 4; freq++) {
		cmin = max = ctst1 = ctst2 = min = 0;
		GLED_Clear();
		// Search whole space for maximum
		if(B3) {
			ctst2 = 0;
			while(B3);
		} else {
			for(coef = -512; coef < 508; coef += 4) {
				//PORTD ^= 0x4;
				result = Goertzel(coef);
				if(result > max) { max = result; ctst1 = coef; }
				//if(verbose) sprintf(txt, "%d = %d\n", coef, result);
				//if(verbose) USART_String(txt);
				//GLED_Display();
				}
			
			//USART_String("\nStage1: ");
			//sprintf(txt, "%d = %d\n", ctst1, max);
			//USART_String(txt);
			//set_alpha("RX TST2");
			//set_number(ctst1);
			// search local space for best fine-tuning
			for(coef = ctst1 - 16; coef < ctst1 + 16; coef++) {
				for(i = 20; i; i--) {
					//PORTD ^= 0x4;
					result = Goertzel(coef);
					if(i == 20) min = max = result; 
					if(result < min) min = result;
					if(result > max) max = result;
					GLED_Display();
				}
				if(min > cmin) {
					ctst2 = coef;
					cmin = min;
				}
				//if(verbose) sprintf(txt, "%d = %d, %d\n", coef, max, min);
				//if(verbose) USART_String(txt);
				//PORTD &= ~0x4;
				//GLED_Display();
				//if(ADC_tst) set_number(ADC);
			}
		}
		USART_String("\nFinal: ");
		sprintf(txt, "%d %d   %d %d\n", freq >> 2, ctst2, cmin, freq);
		USART_String(txt);
		set_alpha(txt);
		set_icon(3 << ((freq & 3) << 1));
		min = 20;
		do {
			result = Goertzel(ctst2);
			if(result <= 10) min--;
			set_number(result);
			for(i = 0; i < 100; i++) GLED_Display();
		} while((!B2) && (!B3));
		Receiver_Coefficients[(short)(freq)] = ctst2;
	}
	for(i = 0; i < (Coef_Zones - 1); i++) Receiver_Coefficients[i] = Receiver_Coefficients[(i * 4) + 6];
	for(i = 0; i < (Coef_Zones * 4); i++) {
		EEPROM_write((i<<1)+31, (unsigned char)(Receiver_Coefficients[i]));
		EEPROM_write((i<<1)+31+1, (unsigned char)(Receiver_Coefficients[i] >> 8));
	}
	GLED_Clear();
}

void Receiver_Test(void)
{
	short result;
	short max;
	char i;
	unsigned char src = 0;
	char txt[10];
	PRR &= ~0x01;	// enable ADC
	ADMUX = 0x40 + 2;	// Vcc, ADC2
	ADC_clr;
	USART_String("Goertzel\n");
	while(1) {
		//PORTD |= 0x4;
		max = result = 0;
		result = GoertzelRun(&Receiver_Coefficients[src]) + 1;
		sprintf(txt, "%2d %4d", src >> 2, Receiver_Coefficients[src + result - 1]);
		en_keys;
		set_alpha(txt);
		if(magnitude <= true_sig) result = 0;
		//PORTD &= ~0x4;
		if(B2) { src += 4; while(B2); }
		if(src >= (Coef_Zones << 2)) src = 0;
		set_LEDs(result);
		set_number(magnitude);
		if(result) set_icon(3 << ((result-1) << 1));
		else set_icon(0);
		//sprintf(txt, "%d   ", Receiver_Coefficients[result - 1]);
		//set_alpha(txt);
		for(i = 0; i < 100; i++) GLED_Display();
	}
}


void AddSample(unsigned char rawchannel[(packet_size * 8) / num_channels][num_channels], unsigned char sample)
// Adds a single sample to 'rawchannel' divided into respected channels
{
	int i, m;
	for(i = 0; i < num_channels; i++) {
		for(m = ((packet_size * 8) / num_channels) - 1; m > 0; m--) {
			rawchannel[m][i] = (rawchannel[m][i] << 1) | ((rawchannel[m - 1][i] & 0x80)?1:0);
		}
		rawchannel[0][i] = (rawchannel[0][i] << 1) | (sample & 0x01);
		sample = sample >> 1;
	}
}

unsigned char GenPacket(unsigned char rawchannel[(packet_size * 8) / num_channels][num_channels], unsigned char tst_packet[packet_size])
// Takes 'rawchannel' and places' possible post-processed packet into 'tst_packet'
{
	unsigned char segment = 0;
	unsigned char accuracy = 0;
	unsigned char tmp_accuracy;
	int m, n, i;
	n = -1;
	for(m = ((packet_size * 8) / num_channels) - 1; m >= 0; m--) {
		segment = 0;
		for(i = num_channels - 1; i >= 0; i--) {
			segment = segment << 1;
			tmp_accuracy = gcount(rawchannel[m][i]);
			if(tmp_accuracy >= 4) {
				segment |= 1;
				accuracy += 8 - tmp_accuracy;
			} else {
				accuracy += tmp_accuracy;
			}
			n++;
		}
		tst_packet[n >> 3] = (tst_packet[n >> 3] << num_channels) | segment;
	}
	return accuracy;
}


/********RX Interface****************/
char RX_Packets(short *wait, char symbols, unsigned char flag)
// returns after 'wait' time units or if an incoming packet has been received
{
	unsigned char rawchannel[(packet_size * 8) / num_channels][num_channels];
	//calculate the average accuracy every 8 packets;
	unsigned int cur_accuracy = 0;
	//to calculate how many packets received in the transmission;
	unsigned char tst_packet[packet_size];
	//unsigned char fin_packet[packet_size];
	unsigned char n = 0;
	char Rx = 0;
	char coef = 0;
	unsigned char binary = 0;
	short i;
	if(flag==0){
		PRR &= ~0x21;	// enable timer0 & ADC
		
		ADMUX = 0x40 + 2;	// Vcc, ADC2
		ADC_clr;
		// Start Timer0 Utilizing a 4x faster timing environment
		TCCR0B = 0x04;
		do {
			sleep_enable();
			sleep_mode();
			sleep_disable();
			#if wired
			magnitude = 0;
			binary = (PINC & 0x18) >> 3;
			if(binary == 2) magnitude = 101;
			#else
			binary = GoertzelRun(&Receiver_Coefficients[0]);
			//PORTC ^= 0x8;
			#endif
			(*wait)--;
			if((magnitude > 100)) Rx = 1;
		} while((*wait) && (!Rx));
		AddSample(rawchannel, 2);
	}
	if(Rx || flag==1) { 
		set_LEDs(2);
		n = (symbols * 8) - 1;
		coef = (binary << 2) + 4;
		do {
			/****************************** Binary Software Decoder ****************************/
			//PORTD ^= 0x4;
			//en_keys;
			sleep_enable();
			sleep_mode();
			sleep_disable();
			#if wired
			binary = (PINC & 0x18) >> 3;
			magnitude = 101;
			#else
			binary = GoertzelRun(&Receiver_Coefficients[(unsigned char)coef]);
			#endif
			AddSample(rawchannel, binary);
			//PORTC ^= 0x8;
			(*wait)--;
			
			n--;
			// ************************** Packet Analysis ************************ //
		} while(n);
		cur_accuracy = GenPacket(rawchannel, tst_packet);
		for(i = 0; i < (symbols >> 2); i++) RXpacket[i] = tst_packet[i]; 
	} else RXpacket[0] = 0;
	return Rx;
}

