#include "aloha.h"



void Delay(unsigned int ms)
{
	unsigned int i,j;
	for(i=0;i<ms;i++){
		for(j=0;j<0xffff;j++);
	}
};


unsigned char CRC_Create(unsigned char number)
{
	unsigned char remainder=0;
	unsigned char i,j;
	
	for(i=0;i<number;i++){
		remainder=remainder ^ TXpacket[i+2];
		for(j=0;j<8;j++){
			if(remainder & 0x80){
				remainder=(remainder<<1) ^ 0x7;
			}
			else{
				remainder=(remainder<<1);
			}
			remainder=(remainder & 0xFFFF);
		}
	}
	
			return remainder;
}

unsigned char CRC_Check(unsigned char number)
{
	unsigned char remainder=0;
	unsigned char i,j;
	
	for(i=0;i<number;i++){
		remainder=remainder ^ RXpacket[i];
		for(j=0;j<8;j++){
			if(remainder & 0x80){
				remainder=(remainder<<1) ^ 0x7;
			}
			else{
				remainder=(remainder<<1);
			}
		}
		remainder=(remainder & 0xFFFF);
	}
	
			return (remainder^RXpacket[number]);
};
void PacketCompose(PACKET p)
{
	unsigned char i;
	
	if (p.ID==ID_DATA){
		TXpacket[0]=p.ID | p.Dest;
		TXpacket[1]=(p.Source<<4) | (p.Length);

		for(i=0;i<p.Length;i++){
			TXpacket[2+i]=0x57;
			TX_data++;
		}

		TXpacket[2+p.Length]=CRC_Create(p.Length);
		
	}
	else {
		TXpacket[0]=p.ID | p.Dest;
		TXpacket[1]=(p.Source<<4) | (p.Length);	

	}

};

PACKET Decompose(void)
{

	PACKET p;

	p.ID=RXpacket[0]&0xF0;
	p.Dest=RXpacket[0]&0x0F;
	p.Source=RXpacket[1]>>4;
	p.Length=RXpacket[1]&0x0F;

	return p;	

};

void SaveData(PACKET p)
{	unsigned char i;
	static unsigned int array_number=0;
	for(i=0;i<p.Length;i++){	
		DataArray[array_number]=p.Data[i];
		array_number++;
	}

};

PACKET RecPacket(short *wait, char symbols)
{
	PACKET p;
	//call physical layer function;
	RX_Packets(wait, symbols);
	p=Decompose();
	return p;
};

void SendPacket(PACKET p){
	unsigned char symbols;
	PacketCompose(p);
	symbols=(p.Length+2)*4+2;
	//call physical layer function;
	TX_Packet(symbols);

};
void SendACK( unsigned char TO)
{
	Status=STATUS_TX;
	P_ACK.Source=DEVICE_ID;
	P_ACK.Dest=TO;
	P_ACK.ID=ID_ACK;
//	ACK.CRC=;  //TBD

	SendPacket(P_ACK);

};

void SendRTS(unsigned char TO)
{	
	//PACKET RTS;
	Status=STATUS_RTS;
	RTS.Source=DEVICE_ID;
	RTS.Dest=TO;
	RTS.ID=ID_RTS;
	RTS.Length=Data_Length;
//	RTS.CRC=;  //TBD
	SendPacket(RTS);

};

void SendCTS(void)
{

	Status=STATUS_CTS;
	CTS.Source=DEVICE_ID;
	//CTS.Dest=p.Source;
	CTS.ID=ID_CTS;
//	CTS.Length=p.Length;
//	RTS.CRC=;  //TBD
	SendPacket(CTS);
};

void SendData(unsigned char TO, unsigned char *data)
{
	PACKET p;
	unsigned char position=0;
	unsigned char *buf;
	unsigned char  retry;
	buf=data;

	while(buf!=NULL){
		p.Data[position]=*buf;
		buf++;
		position++;
	}
	Data_Length=position;
	
		p.Dest=TO;
		p.Source=DEVICE_ID;
		p.ID=ID_DATA;
		p.Length=Data_Length;
//		p.CRC=;
		
		while(Status!=STATUS_IDEL);//ready to send?

		for(retry=0;retry<MAX_RETRY;retry++){
			while(Status==STATUS_DELAY)// if there is no need to delay, send it, else wair for a wile
				Delay(10);
			SendPacket(p);
			Status=STATUS_WAIT_ACK;
			Delay(10);
			if(Status==STATUS_GOT_ACK)
				break;
		}

	Status=STATUS_IDEL;
		
};

unsigned char PickNode(unsigned char nodeID){
	unsigned char i;
	
	i=(nodeID+1)%3;

	while((i==nodeID)||(i==DEVICE_ID)){
		i=(i+1)%3;
	};

	return i;

}

void Aloha()
{
	short wait = wait_RTT;  //Q: how to decide the number on the necessary delay
	unsigned short i;
	//unsigned char tx_data = 0xff;
	//unsigned char rx_data = 0;
	unsigned short datasize;
	//unsigned char temp[2];
	unsigned char CRC=0;
	char Rx = 0;
	unsigned char symbols=0;
	char ACK = 0;
	//TXpacket[0] = 0;
	PACKET p;
	unsigned char trynumber=0;
	
	DEVICE_ID=(unsigned char)EEPROM_read(7);
	DEVICE_ID=DEVICE_ID-1;
	P_DATA.ID=ID_DATA;
	P_DATA.Length=DATA_LENGTH;

	if(PickDest==0)
		P_DATA.Dest=DEST_ID;//(DEVICE_ID+1)%3;//PickNode(p.Source);
	else
		P_DATA.Dest=(DEVICE_ID+1)%3;
	P_DATA.Source=DEVICE_ID;
	PacketCompose(P_DATA);
//	USART_String("Data-> ");
	USART_Number(P_DATA.Dest,16,0);
//	USART_String("\n");	
	symbols=P_DATA.Length*4+12; //8 for header, 4 for crc
	TX_Packet(symbols);
	en_keys;
	n_TXpacket++;
	
	while(1) {

			set_LEDs(0);
			Rx = RX_Packets(&wait, 8, 0);
			en_keys;
		if(Rx) {
			p=Decompose();	
			//if(wait < 100) wait = 100;
	//	if(RXpacket[0]==0x91){	
			if(p.Dest==DEVICE_ID && p.ID==ID_DATA){	// incoming Data - send ACK
				datasize=(p.Length+1)*4;
				RX_Packets(&wait, datasize, 1);
				en_keys;
						
		//		USART_String("Data <-");
		//		USART_Number(p.Source,16,0);
		//		USART_String("\n");				
				CRC=CRC_Check(p.Length);
			//	USART_String("CRC checking end\n");
				if (CRC==0){
				//	for(i=0;i<p.Length;i++){
						n_RXpacket++;
				//	}
				
			//		set_LEDs(1);
			//		USART_String(" CRC OK");
					P_ACK.ID=ID_ACK;
					P_ACK.Length=p.Length;
					if(PickDest==0)
						P_ACK.Dest=DEST_ID;//p.Source;
					else
						P_ACK.Dest=p.Source;
					P_ACK.Source=DEVICE_ID;
					PacketCompose(P_ACK);
					symbols=8; //if send length, then symbols=8;
					set_LEDs(1);
					TX_Packet(symbols);
						en_keys;
					TXACK++;
			//		USART_String(" ACK\n");

				}
				else{
			//		USART_String(" CRC Err\n");
				}
					//	Run_Packet(2);
						
						//	wait = wait_RTT;
							
			}
	
		else if(p.Dest==DEVICE_ID && p.ID==ID_ACK){// ACK returned
			//		USART_String("ACK<-");
					USART_Number(p.Source,16,0);
					if(p.Source==P_DATA.Dest){
			//		USART_String("\n");	
						ACK = 0;
				//		magic = 0;
						P_DATA.ID=ID_DATA;
						P_DATA.Length=DATA_LENGTH;
						if(PickDest==0)
							P_DATA.Dest=DEST_ID;//PickNode(p.Source);
						else
							P_DATA.Dest=PickNode(p.Source);
						P_DATA.Source=DEVICE_ID;
						PacketCompose(P_DATA);
						symbols=P_DATA.Length*4+12;
						set_LEDs(1);
						TX_Packet(symbols);
						en_keys;
						n_TXpacket++;
						RXACK++;
						wait=wait_RTT;
			//			USART_String(" New Data-> ");
			//			USART_Number(P_DATA.Dest,16,0);
			//			USART_String("\n");	
					}
				}
			else {
			//	USART_String("Wrong Packet \n");
			//wait for the ACK to be sent back from another node.
			//	USART_String("Drop\n");
				}
		//	set_LEDs(magic);
		}

		if(wait<=0){// timer ran out, send Data
		//		set_LEDs(magic | 1);
				symbols=P_DATA.Length*4+12;
				if(PickDest==1){
					trynumber++;
					if(trynumber==MAX_RETRY){
						trynumber=0;
						P_DATA.Dest=PickNode(P_DATA.Dest);
					}
					
				}
			//	symbols=14;
				PacketCompose(P_DATA);
			//	USART_Number(TXpacket[0],16,0);
			//		USART_String("  ");
			//		USART_Number(TXpacket[1],16,0);

				set_LEDs(1);
				TX_Packet(symbols);
				en_keys;
				n_TXpacket++;
		//		magic = ACK;
				ACK = 4;
		//		set_LEDs(magic);
				wait = wait_RTT+((ADC&0x0F)<<4);
		//		USART_String("ReSend\n");
		}
		
		if(B1) {
					EEPROM_write(78+PickDest*12, n_RXpacket);
					EEPROM_write(79+PickDest*12, n_TXpacket);
					EEPROM_write(80+PickDest*12, TXACK);
					EEPROM_write(81+PickDest*12, RXACK);

				}
	}
			


};



