#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
//#include <avr/signal.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include "UART.h"
#include "GLED.h"


// The size of a packet in bytes
#define packet_size 8

// the number of sampling channels
#define num_channels 2
#define usart_size 19
#define mcm_symbols 4

#define wired 0
#define verbose 1

#define set_LEDs(n) DDRB = buttons = ((PORTB = 0) | 0xc6 | ((unsigned char)(n) << 3))
#define en_keys DDRB = 0xff ^ (PORTB = 0x39)
#define en_LEDs DDRB = (buttons | (PORTB = 0))
#define en_buzz PORTC &= ~0x10
#define fin_buzz PORTC |= 0x30

#define B1 ((~PINB) & 0x8)
#define B2 ((~PINB) & 0x10)
#define B3 ((~PINB) & 0x20)
#define Bx ((~PINB) & 0x38)
#define set_Cap(n) PORTD = ((PORTD & 0x1f) | ((n & 0x7) << 5))
#define Stop_Emitter TCCR1A = 0x00; TCCR1B = 0x10
// disables pin toggle - pins must be held low
#define Start_Emitter TCCR1A = 0xb0;  TCCR1B = 0x11
// Enables pin toggle

// Temperature equation y = 0.5801x - 76
// (ADC * 37) >> 6;

extern unsigned char TXpacket[packet_size];
extern unsigned char RXpacket[packet_size];
extern unsigned char buttons;
extern unsigned short repeat;
extern unsigned char tb_offset;
extern unsigned char magic;

void disable_watchdog(void);
// Disables watchdog Timer - immune from processor reset
void enable_watchdog(char delay);
// Enables watchdog Timer - 'delay' 0=16ms, 1=32ms, 2=64ms, 3=0.125s, 4=0.25s, 5=0.5s, 6=1.0s, 7=2.0s, 32=4.0s, 33=8.0s

void init(void);
unsigned char gcount(unsigned char x);
unsigned char obfuscate(unsigned char data[packet_size]);
unsigned char Gen_Recovery(unsigned char data[packet_size]);

// TX
void Fetch_Configuration(void);
void Set_Emitter(unsigned char num);
void Emitter_Test(void);
void Run_Transmitter(void);
void BuildPacket(char init);
void TX_Packet(unsigned char bytes);
void Gen_CRC(void);
void Run_Emitter(short sec);

// RX
#define ADC_clr ADCSRA = 0xf5
#define ADC_tst (ADCSRA & 0x10)

#define N 50						// Number of samples
#define SAMPLE_RATE 19231.0			// Sample rate?
#define true_sig 8
#define Coef_Zones 5
extern short magnitude;
void Receiver_Test(void);
void coef_Scan(void);
char RX_Packets(short *wait, char bytes, unsigned char flag);
void Fetch_RxConfiguration(void);
char GoertzelRun(short coef[4]);
//void ADC_capture(void);

// MAC
//unsigned char PickDest=0;
void Aloha(void);
void MACA(void);
void network(void);
